#!/usr/bin/python3
# Import Basic OS functions
import os
# Import modules for CGI handling
import cgi, cgitb
import subprocess
import random
import jinja2
import urllib.request
import re
# enable debugging
cgitb.enable()

# print content type
print("Content-type:text/html\r\n\r\n")

HTML = """
<!DOCTYPE html>
<html><head>
{% if jmol %}
    <script src="js/jsmol/JSmol.min.js"></script>
    <script src="js/jsmol/js/Jmol2.js"></script>
    <script> jmolInitialize("jsmol"); </script>
    <script type="text/javascript">
    var Info = {
      width: 500,
      height: 500,
      j2sPath: "js/jsmol/j2s",
    }
    </script>
{% endif %}
<style>
  #menu {
    background-color: #bdf5fc;
    width: 200px; /* Adjust width as needed */
    padding: 20px;
    box-sizing: border-box;
  }

  #menu b {
    font-size: 24px; /* Larger font size for the menu title */
    color: #333; /* Darker color for better readability */
    margin-bottom: 20px; /* Space below the menu title */
    display: inline-block; /* To enable margin to work */
  }

  #menu a {
    display: block; /* Make each link take its own line */
    color: #007bff; /* A more vibrant link color */
    text-decoration: none; /* Remove underline */
    margin: 10px 0; /* Space between links */
    padding: 8px; /* Padding inside links for larger click area */
    border-radius: 5px; /* Rounded corners for links */
    transition: background-color 0.3s, color 0.3s; /* Smooth transition for hover effects */
  }

  #menu a:hover {
    background-color: #007bff; /* Background color on hover */
    color: #ffffff; /* Text color on hover */
  }

  /* Additional style to remove link spacing and align to the left */
  body {
    margin: 0;
    font-family: Arial, sans-serif; /* Modern font */
  }
</style>
<title></title>
</head>

<body>
  <div id="header" style="background-color:#00c062;text-align:center">
    <h1 style="margin-bottom:0;">Gruppe 7</h1>
  </div>

  <div id="menu" style="background-color:#bdf5fc; height:100%;float:left;padding: 10px;">
    <b>Menu</b><br>
    <a href="main.py">Main page</a><br>
    <br>
    <a href="cgiInput.py">Calculating GC Content</a><br>
    <br>
    <a href="GOR.py">Protein Secondary Structure Prediction</a><br>
    <br>
    <a href="cv.html">GOR validation report</a><br>
    <br>
    <a href="dna2protein.py">DNA2Protein</a><br>    
    <br>
    <a href="callAlignment.py">Alignment</a><br>
    <br>
    <a href="callValidation.py">Alignment Validation</a><br>
    <br>
    <a href="Correlations_Benchmarking_1.pdf">Alignment correlation and benchmarking</a><br>

  </div>

  </div><br><br>
  <div id="introduction" style="background-color:#6affda; height:30%" <pre=""><br>
       Here you can run different alignment algorithms on inputed pair and sequence library files .<br>

  </div>
  <div id="input info" style="background-color:#fc9a00">
  <h3>Input and Output: </h3>
  <p> Input: A sequence library file and a file containing all pairs to be aligned, Please also select a matrix, a mode and your desired output format.<br>
  Output: Score of the predicted alignment using given parameters. If Scores + Alignment is selected, the predicted alignment will also be printed<br>
  </p>
  </div><br>

  {% if result %}

  <div id="content">
  <h3>Result:</h3><br>
  {{ result }}
  </div>


  {% else %}
        {% if hint %}
         <p style="color:#FF0000">{{hint}}<br></p>
        {% endif %}

<script>
function toggleInput() {
    var selection = document.getElementById("inputType").value;
    if (selection == "file") {
        document.getElementById("fileInput").style.display = "";
        document.getElementById("PDBinput").style.display = "none";
    } else if (selection == "PDB") {
        document.getElementById("fileInput").style.display = "none";
        document.getElementById("PDBinput").style.display = "";

    }
}
window.onload = toggleInput; // Ensure correct input is shown on load
</script>
  <form action="callAlignment.py" method="post" enctype="multipart/form-data">
        <select id="inputType" onchange="toggleInput()" name = "inputType">
        <option value="file" selected>Files</option>

        <option value="PDB">PDB ID</option>

        </select><br><br>
        <div id="fileInput">
        <label for="pairs">Pairs File:</label>
        <input type="file" name="pairs" id="pairs"><br><br>

        <label for="seqlib">Sequence Library File:</label>
        <input type="file" name="seqlib" id="seqlib"><br><br>
        </div>
        <div id ="PDBinput">
        <label for="PDB1">PDB ID #1:</label>
        <input type="text" name="PDB1" id="PDB1"><br><br>
        <label for="PDB2">PDB ID #2:</label>
        <input type="text" name="PDB2" id="PDB2"><br><br>
        </div>
        <label for="substitutionmatrix">Substitution Matrix:</label>
            <select name="substitutionmatrix" id="substitutionmatrix">
                <option value="blosum62">BLOSUM62</option>
                <option value="dayhoff">Dayhoff</option>
                <option value="BlakeCohenMatrix">BlakeCohen</option>
                <option value="pam250">PAM250</option>
            </select><br><br>

        <label for="gapopen">Gap Open Penalty:</label>
        <input type="text" name="gapopen" id="gapopen" value="-12"><br><br>

        <label for="gapextend">Gap Extend Penalty:</label>
        <input type="text" name="gapextend" id="gapextend" value="-1"><br><br>

        <label for="mode">Mode:</label>
        <select name="mode" id="mode">
            <option value="local">Local</option>
            <option value="global">Global</option>
            <option value="freeshift">Free Shift</option>
        </select><br><br>

        <input type="checkbox" name="nw" id="nw">
        <label for="nw">Use NW/SW algorithms</label><br><br>
        <label for="format">Output Format:</label>
        <select name="format" id="format">
            <option value="scores">Scores Only</option>
            <option value="ali">Scores + Alignment (plaintext)</option>
            <option value="html">Scores + Alignment (HTML)</option>
        </select><br><br>

        <input type="submit" value="Submit">
    </form>



{% endif %}
{% if jmol %}
<div>
{{jmol}}
</div>
{% endif %}
</body></html>
"""

form = cgi.FieldStorage()
UPLOAD_DIR= 'scripts/tmp'
out= None
jmol = None
inputType = form.getvalue("inputType")
if "mode" in form:


    pairs = ""
    seqlib =""
    name = "q"+(str)(random.randint(1000,1100))
    if inputType == "PDB":
        pairs = UPLOAD_DIR +"/"+ name+".pairs"
        seqlib = UPLOAD_DIR +"/"+ name+ ".seqlib"
        baseUrl = "https://www.rcsb.org/fasta/entry/"
        seqDict = {}
        pdb1 =[]
        pdb2 =[]
        try:
            with urllib.request.urlopen((baseUrl+form["PDB1"].value)) as r:
                with open((UPLOAD_DIR+"/"+name+".txt"), "wb") as file:
                    file.write(r.read())
            with open((UPLOAD_DIR+"/"+name+".txt"), "r", encoding="utf8") as file:
                line = file.readline().strip()
                while line:
                    #this will lead to error when incorect id is given. which is good

                    curID = re.search(">(.*?)[|$]", line).group(1)
                    string=""
                    line = file.readline().strip()
                    while line and line[0]!=">":
                        string = string + line
                        line = file.readline().strip()
                    pdb1.append(curID)
                    seqDict[curID] = string
            with urllib.request.urlopen((baseUrl+form["PDB2"].value)) as r:
                with open((UPLOAD_DIR+"/"+name+".txt"), "wb") as file:
                    file.write(r.read())
            with open((UPLOAD_DIR+"/"+name+".txt"), "r", encoding="utf8") as file:
                line = file.readline().strip()
                while line:

                    curID = re.search(">(.*?)[|$]", line).group(1)
                    string=""
                    line = file.readline().strip()
                    while line and line[0]!=">":
                        string = string + line
                        line = file.readline().strip()
                    pdb2.append(curID)
                    seqDict[curID] = string
        except Exception as e:
            print(str(e))
            print(jinja2.Environment().from_string(HTML).render(hint="Please input valid PDB ID's from www.rcsb.org"))
            quit()
        with open(pairs, "w") as file:
            for id1 in pdb1:
                for id2 in pdb2:
                    file.write(id1 +" " + id2+"\n")
        with open(seqlib, "w") as file:
            for pdb, seq in seqDict.items():
                file.write(pdb+":"+seq+"\n")
        jmol = """
        <script type="text/javascript">
          jmolApplet0 = Jmol.getApplet("jmolApplet0", Info);
          Jmol.script(jmolApplet0,"background black; load ={0}; cartoon ONLY; select helix; color red; select sheet; color green; spin on;")
        </script>
        <script type="text/javascript">
          jmolApplet1 = Jmol.getApplet("jmolApplet1", Info);
          Jmol.script(jmolApplet1,"background black; load ={1}; cartoon ONLY; select helix; color red; select sheet; color green; spin on;")
        </script>
        """.format(form["PDB1"].value,form["PDB2"].value)



    else:
        if "pairs" in form:
            form_file = form['pairs']

            if form_file.filename:
                pairs = os.path.join(UPLOAD_DIR, os.path.basename(form_file.filename))
                with open(pairs, 'wb') as fout:
                    while True:
                        chunk = form_file.file.read(100000)
                        if not chunk:
                            break
                        fout.write(chunk)
        else:
            print(jinja2.Environment().from_string(HTML).render(hint="Please input a file in pairs field"))
            quit()


        if "seqlib" in form:
            form_file = form['seqlib']

            if form_file.filename:
                seqlib = os.path.join(UPLOAD_DIR, os.path.basename(form_file.filename))
                with open(seqlib, 'wb') as fout:
                    while True:
                        chunk = form_file.file.read(100000)
                        if not chunk:
                            break
                        fout.write(chunk)
        else:
            print(jinja2.Environment().from_string(HTML).render(hint="Please input a file in sequence library field"))
            quit()


    if not (form["gapopen"].value.startswith("-") and form["gapopen"].value[1:].isdigit() and  form["gapextend"].value.startswith("-") and form["gapextend"].value[1:].isdigit()):
        print(jinja2.Environment().from_string(HTML).render(hint="Please input negative integers for gap open and gap extend"))
        quit()
    matrix = "matrices/"+form["substitutionmatrix"].value+".mat"
    query = ["java", "-jar","scripts/alignment.jar","--go", (str)(form["gapopen"].value), "--ge", (str)(form["gapextend"].value), "--pairs", pairs,"-m", matrix, "--seqlib", seqlib, "--mode", form["mode"].value,"--format", form["format"].value, "--dpmatrices", UPLOAD_DIR ]
    if "nw" in form:
        query.append("--nw")
    try:
        out = subprocess.check_output(query)
    except:
        print(jinja2.Environment().from_string(HTML).render(hint="Sorry there seems to have been an error, please ensure that sequences only include amino acids(no \"x\")"))
        quit()
    if out != None:
        out = out.decode('utf-8', 'ignore')
    if form["format"].value == "ali":
        with open((UPLOAD_DIR+"/"+name+".txt"), "w") as file:
            file.write(out)





result = None
if out:

    result=""
    if form["format"].value != "html":
        if form["format"].value =="ali":
            result = result + "<p><a href = \""+(UPLOAD_DIR+"/"+name+".txt")+"\" download>Download</a><br></p>"
        result= result +"<pre>" +out+"</pre>"
    else:
        result = result + out
headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:23.0) Gecko/20100101 Firefox/23.0'}
print(jinja2.Environment().from_string(HTML).render(result=result, jmol=jmol))
